package Aggregation;

import PrologDB.Tuple;
import java.util.function.BiFunction;


public class DoubleAgg extends Reducer {
    Double agg;
    BiFunction<Double,Tuple,Double> fun;

    /**
     * 
     * @param fieldName -- name of field.
     * @param fun -- like (d,t) → d + t.getDouble(column)
     *                    (d,t) → Math.min(d,t.getDouble(column))
     */
    public DoubleAgg(String fieldName, BiFunction<Double,Tuple,Double> fun) {
       super(fieldName);
       this.fun = fun;
       reset();
    }
    
    public void add(Tuple t) {
        agg = fun.apply(agg,t);
    }

    public String[] getAccumulated() {
        String[] result = new String[1];
        result[0] = agg.toString();
        return result;
    }

    @Override
    public void reset() {
        agg = 0.0;
    }
}
