package Aggregation;

import PrologDB.Tuple;
import java.util.function.BiFunction;


public class DoubleSum extends Reducer {
    Double agg;
    String infieldName;

    /**
     * 
     * @param outfieldName -- name of aggregation field.
     * @param infieldName  -- name of double-valued field to aggregate
     */
    public DoubleSum(String outfieldName, String infieldName ) {
       super(outfieldName);
       reset();
       this.infieldName = infieldName;
    }
    
    public void add(Tuple t) {
        agg = agg + t.getDouble(infieldName);
    }

    public String[] getAccumulated() {
        String[] result = new String[1];
        result[0] = agg.toString();
        return result;
    }

    @Override
    public void reset() {
        agg = 0.0;
    }
}
