package Aggregation;

import PrologDB.Tuple;
import java.util.function.BiFunction;

/**
 * use for integer aggregations
 */
public class IntAgg extends Reducer {
    int agg;
    BiFunction<Integer, Tuple, Integer> f;

    /**
     *
     * @param outFieldName - column descriptor of aggregate column 
     * (use "n" or "'n'" for name n and indicate if values are quoted
     * @param fun -- like (i,t) → i + t.getInt(column) 
     * (i,t) → Math.min(i,t.getInt(column))
     */
    public IntAgg(String outFieldName, BiFunction<Integer, Tuple, Integer> fun) {
        super(outFieldName);
        f = fun;
        reset();
    }

    @Override
    public void add(Tuple t) {
        agg = f.apply(agg, t);
    }

    public String[] getAccumulated() {
        String[] result = new String[1];
        result[0] = agg + "";
        return result;
    }

    @Override
    public void reset() {
        agg = 0;
    }
}
