
package MDL;

import MDLUtilities.Marquee2In_0Out;
import PrologDB.DB;
import PrologDB.Table;
import PrologDB.Tuple;


public class DBinDB {
    
    // not yet ready to come online -- is database1 embedded in database2?
    
    public static void main(String... args) {
        // Step 1: standard marquee processing
        Marquee2In_0Out mark = new Marquee2In_0Out(DBinDB.class, ".pl", ".pl", args);
        String inputFileName0 = mark.getInputFileName();
        String inputFileName1 = mark.getInputFileName1();
        
        // Step 2:  read in both files
        DB db0 = DB.read(inputFileName0);
        DB db1 = DB.read(inputFileName1);
        
        // Step 3: report table differences
        for (Table t0 : db0.getTables()) {
            boolean tabFound = false;
            for (Table t1 : db1.getTables()) {
                if (t0.getName().equals(t1.getName())) {
                    // we have tables with corresponding names
                    tabFound = true;
                    if (t0.getSchema().equals(t1.getSchema())) {
                        // if we get here, we can compare tuples
                        for (Tuple r0 : t0.tuples()) {
                            boolean tupFound = false;
                            for (Tuple r1: t1.tuples()) {
                                if (r0.equals(r1)) {
                                    tupFound = true;
                                    break;
                                }
                            }
                            if (!tupFound) {
                               System.out.format("tuple %s missing in second DB table %s\n",r0.toString(),t1.getName());
                            }
                        }
                    } else {
                        System.out.format("corresponding tables with name %s have different schemas\n",t0.getName());
                        break;
                    }
                } 
            }
            if (!tabFound) {
                System.out.format("table %s in first DB has no corresponding table in second DB/n",t0.getName());
            }
        }
    }
    
}
