package MDL;

import PrologDB.DBSchema;
import MDLUtilities.Marquee1In_1Out;
import PrologDB.OOSchema;

/**
 * OO2Schema translates S.ooschema.pl to S.schema.pl
 * that is, it propagates supertable attributes to subtable attributes
 */
public class OO2DBSchema {
    
    /**
     * reads X.ooschema.pl and outputs X.schema.pl by flattening -- propagating
     * columns of supertables to subtables
     * @param args -- X.ooschema.pl
     */
    public static void main(String... args) {
        
        // Step 1: standard marquee processing
        Marquee1In_1Out mark = new Marquee1In_1Out(OO2DBSchema.class, ".ooschema.pl", ".schema.pl", args);
        String inputFileName = mark.getInputFileName();
        String outputFileName = mark.getOutputFileName();

        // Step 2: do the work now
        OOSchema oodbs = OOSchema.read(inputFileName);
        DBSchema dbs = oodbs.finishAndPropagateAttributes();
        dbs.print(outputFileName);
    }
}
