package MDLUtilities;

import PrologDB.DB;

/** standard MDELite Marquee processing */
public class Marquee1DBin_1Out  {

    String outputPattern1;
    String outputFileName;

    /** standard usage:
        Marquee1DBIn_1Out mark = new Marquee1DBIn_1Out(THIS.class, ".c.d", args);
        String outputFileName = mark.getOutputFileName();
     * @param cls -- class object of MDELite application
     * @param db -- database input (rather than database file input)
     * @param outputFilePattern -- one output pattern
     * @param args -- command-line arguments from main(args) (should only be 1)
     */
    public Marquee1DBin_1Out(Class cls, DB db, String outputFilePattern, String args[]) {
        this.outputPattern1 = outputFilePattern;
        int al = args.length;
        if (al!=1)
            throw Error.toss(Error.callError, cls.getName(), al);
        if (!outputFileName.endsWith(outputPattern1))
            outputFileName = outputFileName+outputPattern1;
    }
    
    /**
     * @return -- output file name 
     */
    public String getOutputFileName() {
        return outputFileName;
    }
}
