package MDLUtilities;

/** general Marquee 1 argument programs */
public class Marquee4In_0Out extends MarqueeCommon {
    String inputPattern3, inputPattern4;

    /** general Marquee for all 3 input programs 
     * standard usage:
        Marquee3In_0Out mark = new Marquee3In_0Out(THIS.class, ".a.b", ".c.d", ".e.f", ".h.i" args);
        String inputFileName = mark.getInputFileName();
        String inputFileName1 = mark.getInputFileName1();
        String inputFileName2 = mark.getInputFileName2();
        String inputFileName3 = mark.getInputFileName3();
        String AppName = mark.getAppName();
     * @param cls -- class object of the Conformance Program
     * @param pattern1 -- file pattern (".a.b") to match/process
     * @param pattern2 -- file pattern (".c.d") to match/process
     * @param pattern3 -- file pattern (".e.f") to match/process
     * @param pattern4 -- file pattern (".h.i") to match/process
     * @param args -- from main(args)
     */
    public Marquee4In_0Out(Class cls, String pattern1, String pattern2, String pattern3, String pattern4, String args[]) {
        this.cls = cls;
        this.inputPattern1 = pattern1;
        this.inputPattern2 = pattern2;
        this.inputPattern3 = pattern3;
        this.inputPattern4 = pattern4;
        this.args = args;
        insist(3);
    }
    
    /** to pacify whiney compiler */
    private Marquee4In_0Out() {}
   

    /**
     * display generic marquee for Conformance files
     * @param msg -- specialized error message to print, otherwise ""
     */
    public void displayMarquee(String msg) {
        System.out.format("\nUsage: %s top%s bottom%s extra%s\n", cls.getName(), inputPattern1, inputPattern2, inputPattern3);
        if(msg!=null) {
            System.out.format("\n       %s\n", msg);
        }
        System.exit(0);
    }

    /**
     * @return  name of the input file that is to be validated
     */
    @Override
    public String getInputFileName() {
        if (!args[0].contains(".")) //NEW
            return args[0]+inputPattern1;
        if (!args[0].endsWith(inputPattern1)) {
            displayMarquee(args[0] + " submitted as input");
        }
        return args[0];
    }
    
    /**
     * @return  name of 2nd input file 
     */
    public String getInputFileName1() {
        if (!args[1].contains(".")) //NEW
            return args[1]+inputPattern2;
        if (!args[1].endsWith(inputPattern2)) {
            displayMarquee(args[1] + " submitted as input");
        }
        return args[1];
    }
    
    /**
     * @return  name of 2nd input file 
     */
    public String getInputFileName2() {
        if (!args[2].contains(".")) //NEW
            return args[2]+inputPattern3;
        if (!args[2].endsWith(inputPattern3)) {
            displayMarquee(args[2] + " submitted as input");
        }
        return args[2];
    }
    
    /**
     * @return  name of 3nd input file 
     */
    public String getInputFileName3() {
        if (!args[3].contains(".")) //NEW
            return args[3]+inputPattern3;
        if (!args[3].endsWith(inputPattern3)) {
            displayMarquee(args[3] + " submitted as input");
        }
        return args[3];
    }

}
