package MDLUtilities;

import PrologDB.DB;
import PrologDB.Schema;
import java.io.PrintStream;

/**
 * for methods that return databases AND an output stream
 */
public class Result {

    public final PrintStream out;
    public final String outputFileName;
    public final DB db;
    public final Schema schema;

    public Result(PrintStream out, DB db) {
        this.out = out;
        this.db = db;
        this.schema = null;
        this.outputFileName = "";
    }

    public Result(String outputFileName, DB db) {
        this.out = null;
        this.db = db;
        this.schema = null;
        this.outputFileName = outputFileName;
    }

    public Result(Schema s) {
        this.out = null;
        this.db = null;
        this.schema = s;
        this.outputFileName = "";
    }

    public void outputDB() {
        if (out != null) {
            db.print(out);
        } else {
            db.print(outputFileName);
        }
    }

    public void outputSchema(String filename) {
        schema.print(filename);
    }
}
