package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * a Dot is "." token
 */
public class Dot extends FixedStringToken {
    public static final String tok = ".";

    /**
     * Standard constructor
     */
    public Dot() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public Dot(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Dot klone(LineToParse l) {
        return new Dot(l);
    }

    @Override
    public String getEmsg() {
        return "dot";
    }
}
