package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * LeftParen '(' token
 */
public class LeftParen extends FixedStringToken {

    public static final String tok = "(";

    /**
     * Standard constructor
     */
    public LeftParen() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public LeftParen(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public String getEmsg() {
        return tok;
    }

    @Override
    public LeftParen klone(LineToParse l) {
        return new LeftParen(l);
    }
}
