package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * RightBracket is "]"
 */
public class RightBracket extends FixedStringToken {

    public static final String tok = "]";

    /**
     * Standard constructor
     */
    public RightBracket() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public RightBracket(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public String getEmsg() {
        return tok;
    }

    @Override
    public RightBracket klone(LineToParse l) {
        return new RightBracket(l);
    }
}
