package Parsing.DBPrimitives.FixedStrTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * RightParen is ")"
 */
public class RightParen extends FixedStringToken {

    public static final String tok = ")";

    /**
     * Standard constructor
     */
    public RightParen() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public RightParen(LineToParse l) {
        super(l, false);
    }

    @Override
    public RightParen klone(LineToParse l) {
        return new RightParen(l);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
