package Parsing.DBPrimitives.Lists;

import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.PrimTokens.NumBer;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.GeneralPrimitives.PrimTokens.QuotedString;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.LineParsers.LineToParse;

/** TupleValues is a sequence of I(,I)*, where I = single-quoted-string | name | number ; */
public class TupleValues extends NonEmptyList { // comma separated tuple values

    /** Standard constructor */
    public TupleValues() {
        super(new Choose1(new QuotedString(), new NumBer(), 
                new Name()), new Comma(), true );
    }

    /** Standard constructor with line to parse 
     * @param l -- line to parse
     */
    public TupleValues(LineToParse l) {
        super(new Choose1(new QuotedString(), new NumBer(), new Name()), new Comma(), 
                true);
    }
    
    @Override
    public TupleValues klone(LineToParse l) {
        return new TupleValues(l);
    }
}
