
package Parsing.DBPrimitives.Patterns;

// extended column declaration

import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.GeneralPrimitives.SaveTokens.Nothing;
import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.SaveToken.Option;
import Parsing.TBPrims.SaveToken.TaBleModifier;
import Parsing.TBPrims.SkipTokens.Colon;


// kind = ':' modifier kindname ;

public class ColonKind extends Pattern {
    /** Standard constructor */
    public ColonKind () {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public ColonKind(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Colon(),                                   // ":"
             new Choose1( new Option(),  new TaBleModifier(), new Nothing()), // modifier
             new Name()                                     // kindname
            };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public Token klone(LineToParse l) {
        return new ColonKind(l);
    }
    
}
