package Parsing.DBPrimitives.Patterns;

import Parsing.DBPrimitives.FixedStrTokens.AbsTaBle;
import Parsing.DBPrimitives.FixedStrTokens.TaBle;
import Parsing.DBPrimitives.FixedStrTokens.RightParen;
import Parsing.DBPrimitives.FixedStrTokens.RightBracket;
import Parsing.DBPrimitives.FixedStrTokens.LeftParen;
import Parsing.DBPrimitives.FixedStrTokens.LeftBracket;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.Lists.XColumnDecl;

/** table Statement : table( Name, [ columnDecl }). */
public class XTableStmt extends Pattern {
    
    /** Standard constructor */
    public XTableStmt() {
        super();
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToPars
     */
    public XTableStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Choose1(new TaBle(), new AbsTaBle()),
             new LeftParen(), new Name(), new Comma(), 
             new LeftBracket(), new XColumnDecl(), new RightBracket(), 
             new RightParen(), new Dot(), new End() };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public XTableStmt klone(LineToParse l) {
        return new XTableStmt(l);
    }
}
