package Parsing.GeneralPrimitives.Optionals;

import Parsing.GeneralPrimitives.Token;
import Parsing.LineParsers.LineToParse;

/** optional token [t] */
public class Optional extends Token {

    Token opt;

    /** Standard constructor 
     * @param opt -- token that could be optional
     */
    public Optional(Token opt) {
        this.opt = opt;
    }

    /** Standard constructor with line to parse
     * @param opt -- token that could be optional
     * @param l -- line to parse
     */
    public Optional(Token opt, LineToParse l) {
        super(l);
        this.opt = opt;
    }

    private Token o;
    private boolean realAnswer;

    @Override
    public boolean canParse() {
//        toBeParsed.AssertNotAtEnd(this);
        o = opt.klone(toBeParsed);
        realAnswer = o.canParse(); // consume opt token
        return true; // we cheat -- we tell our caller that we CAN parse  and ***
    }

    @Override
    public void consumeToken() {
//        o.consumeToken();  ** we consume nothing
    }

    @Override
    public void parse() {
        if (realAnswer == false) {  // and really parse when we consume
            return;
        }
        o.parse();
    }

    @Override
    public Optional klone(LineToParse l) {
        return new Optional(opt, l);
    }

    @Override
    public String getEmsg() {
        return "optional";
    }

}
