package Parsing.TBPrims;

import Parsing.GeneralPrimitives.*;
import Parsing.LineParsers.LineToParse;

/** name Arrow token is 'dash greater than' which outputs a "arrow" instruction */
public class Arrow extends Token {
    public static final String tok = "->";

    /** Standard constructor */
    public Arrow() {
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public Arrow(LineToParse l) {
        super(l);
    }
    
    @Override
    public boolean canParse() { // consume name, if canParse == true
        toBeParsed.AssertNotAtEnd(this);
        return toBeParsed.startsWith(tok);
    }
    
    @Override
    public void consumeToken() {
        toBeParsed.returnSave(tok.length());
    }
    
    @Override
    public void parse() {
        toBeParsed.parseSaveQualified(this);
    }
    
    @Override
    public Arrow klone(LineToParse l) {
        return new Arrow(l);
    }
    
    @Override
    public String getEmsg() { return tok; }
}
