package Parsing.TBPrims.Lists;

import Parsing.TBPrims.Patterns.Expr;
import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.LineParsers.LineToParse;

/** a ExprList is Expr (,Expr)* */
public class ExprList extends NonEmptyList { // comma separated names
    
    /** Standard constructor */
    public ExprList() {
        super(new Expr(), new Comma(), false);
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public ExprList(LineToParse l) {
        super( new Expr(), new Comma(), l, false);
    }

    @Override
    public ExprList klone(LineToParse l) {
        return new ExprList(l);
    }

}
