package Parsing.TBPrims.Lists;

import Parsing.DBPrimitives.FixedStrTokens.Comma;
import Parsing.DBPrimitives.Patterns.XColumn;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.NonEmptyList;
import Parsing.GeneralPrimitives.Optionals.Optional;
import Parsing.GeneralPrimitives.PrimTokens.QuotedString;
import Parsing.LineParsers.LineToParse;

/** a ExprList is Expr (,Expr)* */
public class XColumnDecl extends Optional { // comma separated names
    
    
    /** Standard constructor */
    public XColumnDecl() {
        super(new NonEmptyList(new Choose1(new XColumn(), new QuotedString()), new Comma(), true));
    }
    
    /** Standard constructor with line to parse
     * @param l -- line to parse
     */
    public XColumnDecl(LineToParse l) {
        super(new NonEmptyList(new Choose1(new XColumn(), new QuotedString()), new Comma(), true),l);
    }
    
    @Override
    public XColumnDecl klone(LineToParse l) {
        return new XColumnDecl(l);
    }
}
