package Parsing.TBPrims.Patterns;

import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import Parsing.TBPrims.Arrow;
import Parsing.TBPrims.Lists.FuncTypeList;

/**
 * function call arguments '(' ExprList ')' (last is push)
 */
public class FTLArrow extends Pattern {

    /**
     * Standard constructor
     */
    public FTLArrow() {
        super();
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public FTLArrow(LineToParse l) {
        super(l);
    }

    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = {new FuncTypeList(), new Arrow()};
            sequence = s;
        }
        return sequence;
    }

    @Override
    public FTLArrow klone(LineToParse l) {
        return new FTLArrow(l);
    }
}
