package Parsing.TBPrims.Patterns;

import Parsing.TBPrims.Arrow;
import Parsing.TBPrims.SkipTokens.Colon;
import Parsing.DBPrimitives.FixedStrTokens.Dot;
import Parsing.GeneralPrimitives.Optionals.Choose1;
import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.GeneralPrimitives.PrimTokens.Name;
import Parsing.LineParsers.LineToParse;

/**
 * function line statement: name name+ "arrow" name+
 */
public class FuncStmt extends Pattern {

    /** Standard constructor */
    public FuncStmt() {
        super();
    }

    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public FuncStmt(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            {new Name(), new Colon(),                    // name :
             new Choose1( new Arrow(), new FTLArrow()),  //  ->  or (functype)+ ->
             new FuncType(), new Dot(), new End()};      // funtype . 
            sequence = s;
        }
        return sequence;
    }

    @Override
    public FuncStmt klone(LineToParse l) {
        return new FuncStmt(l);
    }
}
