package Parsing.TBPrims.SaveToken;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * an Equals is "=" token
 */
public class Equals extends FixedStringToken {

    public static final String tok = "=";
    public static final char toc = '=';
    public static final int toklen = tok.length();

    /**
     * Standard constructor
     */
    public Equals() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public Equals(LineToParse l) {
        super(l, true);
    }

    @Override
    public boolean canParse() { // consume name, if canParse == true
        toBeParsed.AssertNotAtEnd(this);
        char c = toBeParsed.peek();
        return c == toc;
    }

    @Override
    public void consumeToken() {
        toBeParsed.returnSave(toklen);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public void parse() {
        toBeParsed.parseSkipQualified(this);
        toBeParsed.add2ParseList(tok);
    }

    @Override
    public Equals klone(LineToParse l) {
        return new Equals(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
