package Parsing.TBPrims.SaveToken;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * name RightParenPush token is ')' which outputs a "push" instruction
 */
public class RightParenPush extends FixedStringToken {

    public static final String tok = ")";
    public static final int toklen = tok.length();
    public static final char toc = ')';

    /**
     * Standard constructor
     */
    public RightParenPush() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public RightParenPush(LineToParse l) {
        super(l, true);
    }

    @Override
    public boolean canParse() { // consume name, if canParse == true
        toBeParsed.AssertNotAtEnd(this);
        char c = toBeParsed.peek();
        return c == toc;
    }

    @Override
    public void consumeToken() {
        toBeParsed.returnSave(toklen);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public void parse() {
        toBeParsed.parseSave(this);
    }

    @Override
    public RightParenPush klone(LineToParse l) {
        return new RightParenPush(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
