package Parsing.TBPrims.SkipTokens;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * Nothing returns (empty); Nothingness returns absolutely nothing
 */
public class NothingNess extends FixedStringToken {

    public static final String tok = "";

    /**
     * Standard constructor
     */
    public NothingNess() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- line to parse
     */
    public NothingNess(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public NothingNess klone(LineToParse l) {
        return new NothingNess(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
