package Parsing.YumlPrimitives.FixedSave;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * Yuml token greater-than
 */
public class Gtr extends FixedStringToken {

    public static final String tok = ">";

    /**
     * Standard constructor
     */
    public Gtr() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Gtr(LineToParse l) {
        super(l, true);
    }

    @Override
    public String getEmsg() {
        return tok;
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Gtr klone(LineToParse l) {
        return new Gtr(l);
    }
}
