package Parsing.YumlPrimitives.FixedSave;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * Yuml token ++
 */
public class PlusPlus extends FixedStringToken {

    public static final String tok = "++";

    /**
     * Standard constructor
     */
    public PlusPlus() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public PlusPlus(LineToParse l) {
        super(l, true);
    }

    @Override
    public String getEmsg() {
        return tok;
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public PlusPlus klone(LineToParse l) {
        return new PlusPlus(l);
    }
}
