package Parsing.YumlPrimitives.FixedSave;

import Parsing.LineParsers.LineToParse;
import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;

/**
 * Yuml token: Solid is "-"
 */
public class Solid extends FixedStringToken {

    public static final String tok = "-";

    /**
     * Standard constructor
     */
    public Solid() {
        super(true);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Solid(LineToParse l) {
        super(l, true);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Solid klone(LineToParse l) {
        return new Solid(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
