package Parsing.YumlPrimitives.FixedSkip;

import Parsing.GeneralPrimitives.SaveTokens.FixedStringToken;
import Parsing.LineParsers.LineToParse;

/**
 * Yuml token: Barrier is "|"
 */
public class Barrier extends FixedStringToken {

    public static String tok = "|";

    /**
     * Standard constructor
     */
    public Barrier() {
        super(false);
    }

    /**
     * Standard constructor with line to parse
     *
     * @param l -- LineToParse
     */
    public Barrier(LineToParse l) {
        super(l, false);
    }

    @Override
    public String getTokenString() {
        return tok;
    }

    @Override
    public Barrier klone(LineToParse l) {
        return new Barrier(l);
    }

    @Override
    public String getEmsg() {
        return tok;
    }
}
