package Parsing.YumlPrimitives.Patterns;

import Parsing.YumlPrimitives.FixedSkip.Barrier;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import Parsing.GeneralPrimitives.Token;
import Parsing.YumlPrimitives.BoxEntry;

/** Yuml Production : Barrier() BoxEntry() */
public class BarrierBoxEntry extends Pattern {
    
    /** Standard constructor */
    public BarrierBoxEntry() {
        super();
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public BarrierBoxEntry(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = { new Barrier(), new BoxEntry() };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public BarrierBoxEntry klone(LineToParse l) {
        return new BarrierBoxEntry(l);
    }
}
