package Parsing.YumlPrimitives.Patterns;

import Parsing.GeneralPrimitives.Token;
import Parsing.GeneralPrimitives.PrimTokens.End;
import Parsing.GeneralPrimitives.Patterns.Pattern;
import Parsing.LineParsers.LineToParse;
import Parsing.GeneralPrimitives.Optionals.Choose1;

/** Yuml Production : YumlLine: Box [connect] end */
public class YumlLine extends Pattern {
    
    /** Standard constructor */
    public YumlLine() {
        super();
    }
    
    /** Standard constructor with line to parse
     * @param l -- LineToParse
     */
    public YumlLine(LineToParse l) {
        super(l);
    }
    
    @Override
    public Token[] getSequence() {
        if (sequence == null) {
            Token[] s = 
            { new Box(), new Choose1( new End(), new Connect()) };
            sequence = s;
        }
        return sequence;
    }

    @Override
    public YumlLine klone(LineToParse l) {
        return new YumlLine(l);
    }
}
