/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package PrologDB;

/**
 *
 * @author don
 */
public enum PrimType {
    Int("int", "int", "INT", false, 'd'),
    Bool("bool", "boolean", "BOOL", false, 'b'),
    Str("str", "String", "STRING", false, 's'),
    QStr("qstr", "String", "STRING", true, 's'),
    Flt("float", "float", "FLOAT", false, 'f'),
    Dbl("dbl", "double", "DOUBLE", false, 'f'),
    Func("func", "func", "FUNC", true, 's');

    private final String name;
    private final String javaName;
    private final String langName;
    private final boolean quoted;
    private final char javaformat;

    /**
     * required constructor
     *
     * @param msg -- string interpretation of error
     */
    private PrimType(String name, String javaName, String langName, boolean quoted, char javaformat) {
        this.name = name;
        this.javaName = javaName;
        this.langName = langName;
        this.quoted = quoted;
        this.javaformat = javaformat;
    }

    public static PrimType convert2PrimType(String str) {
        for (PrimType p : PrimType.values()) {
            if (p.name.equals(str)) {
                return p;
            }
        }
        return null; 
    }

    public static PrimType convertJavaName2PrimType(String str) {
        for (PrimType p : PrimType.values()) {
            if (p.name.equals(str)) {
                return p;
            }
        }
        return null; 
    }

    /**
     * @return string name of enum
     */
    public String getName() {
        return name;
    }

    /**
     * @return java name of type
     */
    public String javaName() {
        return javaName;
    }

    /**
     * @return lang name of type
     */
    public String langName() {
        return langName;
    }

    /**
     * @return java format
     */
    public char javaformat() {
        return javaformat;
    }

    /**
     * @return isQuoted?
     */
    public boolean isQuoted() {
        return quoted;
    }

    public static boolean isPrim(String str) {
        for (PrimType p : PrimType.values()) {
            if (p.name.equals(str)) {
                return true;
            }
        }
        return false;
    }

    public static boolean isExtendedPrim(String s) {
        for (PrimType p : PrimType.values()) {
            if (p.javaName.equals(s)) {
                return true;
            }
        }
        return false;
    }
}
