package Tool;

public class FSMaker extends Boot.MDELite.Common {

    public static void main(String... args) throws Exception {
        main(FSMaker.class, args, current, domains.values(),
             paths.values(),arrows.values());
    }

    static enum domains implements IEnum {
        state(".state.grafit"),
        fsm(".fsm.pl"),
        java(".java"),
        pml(".pml"),
        ;

        public String data; // file type ending

        private domains(String end) {
            this.data = end;
        }

        @Override
        public String getEnd() {
            return data;
        }

        public static domains[] list(domains... args) {
            return args;
        }
    };

    static enum arrows implements PEnum {
        fsmConform( new Triple(
          a -> Grafit.StateConform.main(a),
          domains.list(domains.fsm),
          new domains[0])),
        parse( new Triple(
          a -> Grafit.StateParser.main(a),
          domains.list(domains.state),
          domains.list(domains.fsm))),
        toJava( new Triple(
          a -> Grafit.toJavaCode.main(a),
          domains.list(domains.fsm),
          domains.list(domains.java))),
        toPml( new Triple(
          a -> Grafit.toPromCode.main(a),
          domains.list(domains.fsm),
          domains.list(domains.pml))),
        ;

        private final Triple data;

        private arrows(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }

    static enum paths implements PEnum {
        jav( new Triple(
          a -> FSMaker.jav(a),
          domains.list(domains.state),
          domains.list(domains.java))),
        pml( new Triple(
          a -> FSMaker.pml(a),
          domains.list(domains.state),
          domains.list(domains.pml))),
        ;

        private final Triple data;

        private paths(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }


    static void jav(String[] args) {
        enoughCommandLineArguments(paths.jav, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.toJava, current);
        completed(paths.jav);
    }

    static void pml(String[] args) {
        enoughCommandLineArguments(paths.pml, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.toPml, current);
        completed(paths.pml);
    }
}

