package Tool;

public class alleg extends Boot.MDELite.Common {

    public static void main(String... args) throws Exception {
        main(alleg.class, args, current, domains.values(),
             paths.values(),arrows.values());
    }

    static enum domains implements IEnum {
        Class(".Class.violet"),
        Vpl(".Vpl.pl"),
        Schema(".Schema.pl"),
        Java(".Java"),
        ;

        public String data; // file type ending

        private domains(String end) {
            this.data = end;
        }

        @Override
        public String getEnd() {
            return data;
        }

        public static domains[] list(domains... args) {
            return args;
        }
    };

    static enum arrows implements PEnum {
        VplConform( new Triple(
          a -> Boot.allegory.ClassConform.main(a),
          domains.list(domains.Vpl),
          new domains[0])),
        SchemaConform( new Triple(
          a -> MDL.ReadSchema.main(a),
          domains.list(domains.Schema),
          new domains[0])),
        parse( new Triple(
          a -> Violett.ClassParser.main(a),
          domains.list(domains.Class),
          domains.list(domains.Vpl))),
        toSchema( new Triple(
          a -> Boot.allegory.Vpl2Schema.main(a),
          domains.list(domains.Vpl),
          domains.list(domains.Schema))),
        toJava( new Triple(
          a -> Boot.allegory.VplSchema2Java.main(a),
          domains.list(domains.Schema),
          domains.list(domains.Java))),
        ;

        private final Triple data;

        private arrows(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }

    static enum paths implements PEnum {
        validate( new Triple(
          a -> alleg.validate(a),
          domains.list(domains.Class),
          domains.list(domains.Vpl))),
        onlySchema( new Triple(
          a -> alleg.onlySchema(a),
          domains.list(domains.Class),
          domains.list(domains.Vpl,domains.Schema))),
        full( new Triple(
          a -> alleg.full(a),
          domains.list(domains.Class),
          domains.list(domains.Vpl,domains.Schema,domains.Java))),
        fromSchema( new Triple(
          a -> alleg.fromSchema(a),
          domains.list(domains.Schema),
          domains.list(domains.Java))),
        ;

        private final Triple data;

        private paths(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }


    static void validate(String[] args) {
        enoughCommandLineArguments(paths.validate, args);

        invoke(arrows.parse, current);
        invoke(arrows.VplConform, current);
        completed(paths.validate);
    }

    static void onlySchema(String[] args) {
        enoughCommandLineArguments(paths.onlySchema, args);

        invoke(arrows.parse, current);
        invoke(arrows.VplConform, current);
        invoke(arrows.toSchema, current);
        invoke(arrows.SchemaConform, current);
        completed(paths.onlySchema);
    }

    static void full(String[] args) {
        enoughCommandLineArguments(paths.full, args);

        invoke(arrows.parse, current);
        invoke(arrows.VplConform, current);
        invoke(arrows.toSchema, current);
        invoke(arrows.SchemaConform, current);
        invoke(arrows.toJava, current);
        completed(paths.full);
    }

    static void fromSchema(String[] args) {
        enoughCommandLineArguments(paths.fromSchema, args);

        invoke(arrows.toJava, current);
        completed(paths.fromSchema);
    }
}

