package Tool;

public class fsm extends Boot.MDELite.Common {

    public static void main(String... args) throws Exception {
        main(fsm.class, args, current, domains.values(),
             paths.values(),arrows.values());
    }

    static enum domains implements IEnum {
        state(".state.violet"),
        fsm(".fsm.pl"),
        java(".java"),
        ;

        public String data; // file type ending

        private domains(String end) {
            this.data = end;
        }

        @Override
        public String getEnd() {
            return data;
        }

        public static domains[] list(domains... args) {
            return args;
        }
    };

    static enum arrows implements PEnum {
        fsmConform( new Triple(
          a -> Boot.MDELite.CategoryConform.main(a),
          domains.list(domains.fsm),
          new domains[0])),
        parse( new Triple(
          a -> Violett.StateParser.main(a),
          domains.list(domains.state),
          domains.list(domains.fsm))),
        NestSwitch( new Triple(
          a -> Boot.fsm.kevinFsm2java.main(a),
          domains.list(domains.fsm),
          domains.list(domains.java))),
        DesignPattern( new Triple(
          a -> Boot.fsm.sriramFsm2java.main(a),
          domains.list(domains.fsm),
          domains.list(domains.java))),
        ;

        private final Triple data;

        private arrows(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }

    static enum paths implements PEnum {
        DP( new Triple(
          a -> fsm.DP(a),
          domains.list(domains.state),
          domains.list(domains.java))),
        NS( new Triple(
          a -> fsm.NS(a),
          domains.list(domains.state),
          domains.list(domains.java))),
        validate( new Triple(
          a -> fsm.validate(a),
          domains.list(domains.state),
          new domains[0])),
        ;

        private final Triple data;

        private paths(Triple data) { this.data = data;} 

        @Override
        public Triple get() { return data; }

        @Override
        public IEnum[] getArray(int size) { return new domains[size]; }
    }


    static void DP(String[] args) {
        enoughCommandLineArguments(paths.DP, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.DesignPattern, current);
        completed(paths.DP);
    }

    static void NS(String[] args) {
        enoughCommandLineArguments(paths.NS, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        invoke(arrows.NestSwitch, current);
        completed(paths.NS);
    }

    static void validate(String[] args) {
        enoughCommandLineArguments(paths.validate, args);

        invoke(arrows.parse, current);
        invoke(arrows.fsmConform, current);
        completed(paths.validate);
    }
}

