package DML.PrologDB;

import PrologDB.DB;
import RegTest.Utility;
import java.io.PrintStream;
import org.junit.Test;

public class DBCopyTest {
    static final String testdata = "test/DML/PrologDB/TestData/";
    static final String correct = "test/DML/PrologDB/Correct/";
    static final String errorfile = "trash/error.txt";

    public DBCopyTest() {
    }
    
    void genericCopyDBTest(String localFileName) {
        // localfilename <dbname>.<schemaname>.pl
        DB result = null;
        try {
            result = DB.read(testdata + localFileName);
            String newName = result.getName() + "C";
            result.rename(newName);
            String fullName = result.getFullName();
            result.print(new PrintStream(errorfile));
            Utility.validate(errorfile, correct + fullName, false);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
            org.junit.Assert.fail();
        }
    }

    @Test
    public void noLinks() {
        genericCopyDBTest("noLinks.violetdb.pl");
    }

    @Test
    public void school() {
        genericCopyDBTest("school.violetdb.pl");
    }
    
    @Test
    public void violet() {
        genericCopyDBTest("violet.violetdb.pl");
    }
    
    @Test
    public void wLinks() {
        genericCopyDBTest("wLinks.violetdb.pl");
    }
    
   @Test
    public void i() {
        genericCopyDBTest("i.inh.pl");
    }
    
    @Test
    public void c() {
        genericCopyDBTest("c.complex.pl");
    }
    
    @Test
    public void h() {
        genericCopyDBTest("h.hierarchy.pl");
    }
}
