package MDL;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class Violet2OOSchemaTest {
    
    static final String Trash = "trash/";
    static final String Correct = "test/MDL/Correct/";
    static final String TestData = "test/MDL/TestData/";
    static final String errorFile = Trash + "error.ooschema.pl";
    static final String slash = "/";

    public Violet2OOSchemaTest() {
    }

    @BeforeClass
    public static void setUpClass() {
    }

    @Before
    public void setUp() {
    }

    public void isCorrect(String filename) {
        String oname = Trash+filename+".ooschema.pl";
        Violet2OOSchema.main(TestData + filename + ".class.violet", oname);
        RegTest.Utility.validate(oname, Correct + filename + ".ooschema.pl", false);
    }

    public void isWrong(String filename) {
        String oname = Trash+filename+".txt";
        RegTest.Utility.redirectStdOut(oname);
        try {
            Violet2OOSchema.main(TestData + filename + ".class.violet",oname);
            fail();
        } catch (Exception e) {
            RegTest.Utility.validate(oname, Correct + filename + ".txt", false);
        }
    }

    @Test
    public void Assoc1() {
        isWrong("1Assoc");
    }

    @Test
    public void abcd2() {
        isCorrect("abcd2");
    }

    @Test
    public void nodeEdge1() {
        isWrong("nodeEdge1");
    }

    @Test
    public void nodeEdge3() {
        isCorrect("nodeEdge3");
    }

    @Test
    public void violet1() {
        isCorrect("violet1");
    }

    @Test
    public void abcd1() {
        isWrong("abcd1");
    }

    @Test
    public void assoc() {
        isWrong("assoc");
    }

    @Test
    public void nodeEdge2() {
        isCorrect("nodeEdge2");
    }

    @Test
    public void violet() {
        isWrong("violet");
    }

    @Test
    public void wAbs() {
        isCorrect("wAbs");
    }
}
