package Parsing.DBPrimitives.Patterns;

import Parsing.LineParsers.LineToParse;
import org.junit.Test;


public class XColumnTest {
    
   static final String errorfile = "trash/error.txt";
   static final boolean noSave = false;
   static final boolean Save = true;

    public XColumnTest() {
    }

    public void doit(String input, String outFile, boolean save) {
        String correctFile = "test/Parsing/DBPrimitives/Patterns/Correct/" + outFile + ".txt";
        RegTest.Utility.redirectStdOut(errorfile);
        LineToParse ds = new LineToParse(input,-1);
        System.out.println(input);
        try {
            XColumn xc = new XColumn(ds);
            xc.parse();
            
            System.out.println("parse is successful!");
            for (String s : ds.parseList) {
                System.out.print(s + " ");
            }
            System.out.println();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        if (save) 
            RegTest.Utility.saveCorrectOutput(errorfile, correctFile, false);
        else 
           RegTest.Utility.validate(errorfile, correctFile, false);
    }

    // these tests should all be leagal parsings
    //NOTE: must be blanks at the end of every doit string
    @Test
    public void nk() {
        doit("name : kind ,", "nk",noSave);
    }
    
    @Test
    public void nok() {
        doit("name : option kind ,", "nok",noSave);
    }
    

    
    @Test
    public void qk0() {
        doit("'name' : kind  ,", "qk0",noSave);
    }
    
    @Test
    public void qk1() {
        doit("\"name\" : kind  ,", "qk1",noSave);
    }
    
    @Test
    public void qok() {
        doit("'name': option kind,  ", "qok",noSave);
    }
    
    @Test
    public void qk() {
        doit("'qame' : kind  ,", "qk",noSave);
    }
    
    @Test
    public void q() {
        doit("'qame'   ,", "q",noSave);
    }
    
    @Test
    public void n() {
        doit("qame,   ,", "n",noSave);
    }

    // These tests should be illegal parsings
    
    @Test
    public void ntk() {
        doit("name : table kind  ,", "ntk",noSave);
    }
    
    @Test
    public void qtk() {
        doit("'qame' : table kind,  ", "qtk",noSave);
    }
    
    @Test
    public void nocolon() {
        doit("'qame' kind,  ", "nocolon",noSave);
    }
    
    @Test
    public void all() {
        doit("'qame':option table kind , ", "all",noSave);
    }
    
    @Test
    public void noname() {
        doit(":option table kind  ,", "noname",noSave);
    }
}
