package Parsing.DBPrimitives.Patterns;

import Parsing.LineParsers.LineToParse;
import org.junit.Test;

public class XTableTest {
    static final String errorfile = "trash/error.txt";
    static final boolean Save = true;
    static final boolean noSave = false;

    public XTableTest() {
    }

    public void doit(String input, String outFile, boolean save) {
        String correctFile = "test/Parsing/DBPrimitives/Patterns/Correct/" + outFile + ".txt";
        RegTest.Utility.redirectStdOut(errorfile);
        LineToParse ds = new LineToParse(input,-1);
        System.out.println(input);
        try {
            XTableStmt ts = new XTableStmt(ds);
            ts.parse();
            
            System.out.println("parse is successful!");
            for (String s : ds.parseList) {
                System.out.print(s + " ");
            }
            System.out.println();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        if (save)
            RegTest.Utility.saveCorrectOutput(errorfile, correctFile, false);
         else 
        RegTest.Utility.validate(errorfile, correctFile, false);
    }

    // the following tests should result in correct parsing
    
    @Test
    public void test1() {
        doit("table( abc, [ id,'abc':str,def:int ] ).", "test1",noSave);
    }
    
    @Test
    public void test1a() {
        doit("table( abc, [ 'id','abc','def' ] ).", "test1a",noSave);
    }

    @Test
    public void test2() {
        doit("table(abc,[id,\"abc\",def]).", "test2",noSave);
    }

    @Test
    public void test3() {
        doit("table (   a,  [id] ).", "test3",noSave);
    }

    @Test
    public void test30() {
        doit("table (   a,  [id, a1, a2: option T, a3 ] ).", "test30",noSave);
    }
    
    // the following tests result in parse errors
    
    @Test
    public void test4() {
        doit("dbas ((abc,[id]).", "test4",noSave);
    }

    @Test
    public void test5() {
        doit("table((abc,[id]).", "test5",noSave);
    }
    
    @Test
    public void test6() {
        doit("table(abc,[]).", "test6",noSave);
    }
    
    @Test
    public void test7() {
        doit("table(abc[id]).", "test7",noSave);
    }
    
    @Test
    public void test8() {
        doit("table(abc,[id])", "test8",noSave);
    }
    
    @Test
    public void test40() {
        doit("table (   a,  [id, a1, a2: option T, a3 : Table T ] ).", "test40",noSave);
    }
}
